SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'books catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Cart class
	instanceVariableNames: 'size'!

Cart class
	instanceVariableNames: 'size'!

!Cart class methodsFor: 'class initialization' stamp: 'JuanManuelTastzian 5/29/2013 18:30'!
newEmptyCart
	^self new withoutBooks! !

!Cart class methodsFor: 'error handling' stamp: 'JuanManuelTastzian 5/29/2013 20:54'!
productNotInCatalog
	^ 'Error: The requested product is not present in the catalog'.! !

!Cart class methodsFor: 'class initialization' stamp: 'JuanManuelTastzian 5/29/2013 20:41'!
withCatalog: aCatalog 
	^ self new catalog: aCatalog.! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:53'!
add: aBook 
	(catalog includes: aBook) ifTrue: [books add: aBook] ifFalse: [ Error signal: 'The requested product is not present in the catalog' ]
	! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 18:36'!
books
	^ books! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:43'!
catalog: aCatalog 
	books := Bag new.
	catalog := aCatalog.! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:16'!
includes: aBook 
	^books includes: aBook! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:04'!
isEmpty
	^ self size = 0! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:26'!
numberOfUnitsAddedOf: aBook 
	^(books occurrencesOf: aBook)! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/29/2013 18:38'!
size
	^books size! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 20:27'!
withoutBooks
	books := Bag new.
	catalog := Bag new.! !

Object subclass: #Cashier
	instanceVariableNames: 'priceList merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'message handling' stamp: 'JuanManuelTastzian 6/3/2013 19:12'!
bookNotInPriceList
	^ 'Error: Cannot checkout books that are not in the price list'! !

!Cashier class methodsFor: 'error handling' stamp: 'JuanManuelTastzian 5/29/2013 21:20'!
cartIsEmpty
	^ 'Error: Cannot checkout an empty cart'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 6/5/2013 17:15'!
emptyCreditCard
	^ 'Error: Cannot checkout payment with an empty credit card'! !

!Cashier class methodsFor: 'error handling' stamp: 'JuanManuelTastzian 6/3/2013 20:36'!
expiredCreditCard
	^ 'Error: Cannot checkout payment with expired credit card'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 6/5/2013 17:43'!
stolenCreditCard
	^ 'Error: Cannot checkout payment with a stolen credit card. Calling the cops'! !

!Cashier class methodsFor: 'instance creation' stamp: 'SebaTorres 6/3/2013 02:54'!
withPriceList: aPriceList 
	^self new withPriceList: aPriceList.! !

!Cashier class methodsFor: 'instance creation' stamp: 'JuanManuelTastzian 6/5/2013 20:51'!
withPriceList: aPriceList withMerchantProcessor: aPlagableMerchantProcessor 
	^self new withPriceList: aPriceList withMerchantProcessor: aPlagableMerchantProcessor.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/3/2013 03:24'!
checkout: aCart
	(aCart isEmpty) ifTrue: [ Error signal: 'Cannot checkout an empty cart' ].
	(aCart books asSet = priceList keys asSet) ifFalse: [ Error signal: 'Cannot checkout books that are not in the price list' ].
	^aCart books detectSum: [ :book | priceList at: book ].! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 6/5/2013 21:15'!
checkout: aCart with: aCreditCard
	| amount |
	
	(aCart isEmpty) ifTrue: [ Error signal: 'Cannot checkout an empty cart' ].
	(aCart books asSet = priceList keys asSet) ifFalse: [ Error signal: 'Cannot checkout books that are not in the price list' ].
	
	amount := aCart books detectSum: [ :book | priceList at: book ].
	merchantProcessor debit: amount from: aCreditCard.
	
	"(aCreditCard isExpired) ifTrue: [ Error signal: 'Cannot checkout payment with expired credit card' ].
	^aCart books detectSum: [ :book | priceList at: book ]."! !

!Cashier methodsFor: 'accessing' stamp: 'SebaTorres 6/3/2013 02:56'!
withPriceList: aPriceList 
	priceList := aPriceList.! !

!Cashier methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 20:52'!
withPriceList: aPriceList withMerchantProcessor: aPlagableMerchantProcessor 
	priceList := aPriceList.
	merchantProcessor := aPlagableMerchantProcessor.! !

Object subclass: #CreditCard
	instanceVariableNames: 'expireDate moneyLeft status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'class initialization' stamp: 'SebaTorres 6/10/2013 12:20'!
createWithExpirationDate: anExpirationDate andAmount: anAmount andStatus: aStatus
	^self new newWith: anExpirationDate andAmount:  anAmount andStatus: aStatus! !

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'SebaTorres 6/10/2013 12:39'!
newStolenCreditCard
	self shouldBeImplemented.! !

!CreditCard methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 16:40'!
expireDate
	^expireDate! !

!CreditCard methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 17:19'!
isEmpty
	^ moneyLeft <= 0! !

!CreditCard methodsFor: 'accessing' stamp: 'SebaTorres 6/10/2013 01:58'!
isExpired: aDate
	^ expireDate < aDate.! !

!CreditCard methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 17:41'!
isStolen
	^status = 'stolen'! !

!CreditCard methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 17:19'!
moneyLeft
	^moneyLeft! !

!CreditCard methodsFor: 'accessing' stamp: 'SebaTorres 6/10/2013 12:14'!
newWith: anExpirationDate andAmount: anAmount andStatus: aStatus
	expireDate := anExpirationDate .
	moneyLeft := anAmount .
	status := aStatus .! !

Object subclass: #PlagableMerchantProcessor
	instanceVariableNames: 'blockValidator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PlagableMerchantProcessor class methodsFor: 'class initialization' stamp: 'SebaTorres 6/10/2013 13:09'!
withValidator: aBlockValidator 
	^ self new validator: aBlockValidator.! !

!PlagableMerchantProcessor methodsFor: 'accessing' stamp: 'JuanManuelTastzian 6/5/2013 21:17'!
debit: anAmount from: aCreditCard
	^ blockValidator value: anAmount value: aCreditCard.! !

!PlagableMerchantProcessor methodsFor: 'accessing' stamp: 'SebaTorres 6/10/2013 13:09'!
validator: aBlockValidator
	blockValidator := aBlockValidator.! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'instance creation' stamp: 'JuanManuelTastzian 5/29/2013 18:23'!
emptyCart
	^Cart newEmptyCart! !

!TusLibrosTest methodsFor: 'instance creation' stamp: 'SebaTorres 6/10/2013 12:43'!
newEmptyCreditCard
	^CreditCard createWithExpirationDate:  Date tomorrow andAmount:  0 andStatus: 'not stolen'.! !

!TusLibrosTest methodsFor: 'instance creation' stamp: 'SebaTorres 6/10/2013 12:38'!
newExpiredCreditCard
	^CreditCard createWithExpirationDate:  Date yesterday andAmount:  100 andStatus: 'not stolen'.! !

!TusLibrosTest methodsFor: 'instance creation' stamp: 'SebaTorres 6/10/2013 12:42'!
newStolenCreditCard
	^ CreditCard createWithExpirationDate: Date tomorrow andAmount:  100 andStatus: 'stolen'.! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:01'!
test1CartShouldBeEmptyAfterCreation
	self assert: self emptyCart isEmpty! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'JuanManuelTastzian 5/29/2013 21:19'!
test1cantCheckoutEmptyCart

	| cashier |
	cashier := Cashier new.
	
	self should: [cashier checkout: (self emptyCart) ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cashier cartIsEmpty ]! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:57'!
test2CartSizeShouldBeGreaterThan0AfterAddingABookToIt
	| cart book catalog |
	
	book := 'aBook'.
	catalog := Bag new.
	catalog add: book.
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	
	self assert: (cart size > 0).! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'SebaTorres 6/10/2013 13:29'!
test2cashierChecksOutCorrectly

	"Este test se refiere a que el carrito hace bien el cobro de los libros"

	| cashier aBook catalog priceList anotherBook cart priceBook priceAnotherBook |

	aBook := 'aBook'.
	anotherBook := 'anotherBook'.

	catalog := Bag new.
	catalog add: aBook.
	catalog add: anotherBook .

	"Para crear un diccionario se le asignan asociaciones"
	priceBook := Association key: aBook value: 1.
	priceAnotherBook := Association key: anotherBook value: 3.

	priceList := Dictionary new.
	priceList add: priceBook.
	priceList add: priceAnotherBook.

	cashier := Cashier withPriceList: priceList.

	cart := Cart withCatalog: catalog.
	cart add: aBook. 
	cart add: aBook.
	cart add: anotherBook.
	
	self assert: (cashier checkout: cart) = 5. ! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'JuanManuelTastzian 6/3/2013 20:17'!
test3BooksNotPresentInPriceListCantBeCheckedOut

	"Me fijo que los libros del carrito se encuentren en la lista de precios antes de hacer checkout"

	| cashier aBook catalog priceList anotherBook cart priceBook priceAnotherBook |

	aBook := 'aBook'.
	anotherBook := 'anotherBook'.

	catalog := Bag new.
	catalog add: aBook.
	catalog add: anotherBook .

	priceBook := Association key: aBook value: 1.
	priceAnotherBook := Association key: anotherBook value: 3.

	priceList := Dictionary new.
	priceList add: priceBook.

	cart := Cart withCatalog: catalog.
	cart add: aBook. 
	cart add: anotherBook.

	cashier := Cashier withPriceList: priceList.

	self should: [cashier checkout:  cart ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cashier bookNotInPriceList ]! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:59'!
test3aBookShouldBeListedAfterBeingAddedToACart
	| cart book catalog |
	
	book := 'aBook'.
	catalog := Bag new.
	catalog add: book.
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	self assert: (cart includes: book)! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'SebaTorres 6/10/2013 12:34'!
test4CashierCantCheckOutExpiredCard

	| aBook catalog priceBook priceList cart cashier expiredCreditCard aMerchantProcessor |
	aBook := 'aBook'.

	catalog := Bag new.
	catalog add: aBook.
	
	priceBook := Association key: aBook value: 1.
	
	priceList := Dictionary new.
	priceList add: priceBook.
	
	cart := Cart withCatalog: catalog.
	cart add: aBook. 
	
	aMerchantProcessor := PlagableMerchantProcessor withValidator: [ :anAmount :aCreditCard | 
		Error signal: 'Cannot checkout payment with expired credit card' ].
	
	cashier := Cashier withPriceList: priceList withMerchantProcessor: aMerchantProcessor.
	
	expiredCreditCard := self newExpiredCreditCard.
	
	self should: [cashier checkout: cart with: expiredCreditCard ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cashier expiredCreditCard ].! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:59'!
test4aCartHasOnlyOneBookAfterAddingABookToAnEmptyCart
	| cart book catalog |
	
	book := 'aBook'.
	catalog := Bag new.
	catalog add: book.
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	self assert: (cart includes: book).
	self assert: cart size = 1! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'SebaTorres 6/10/2013 12:42'!
test5CashierCantDebitFromEmptyBankAccount

	| aBook catalog priceBook priceList cart cashier emptyCreditCard aMerchantProcessor |
	aBook := 'aBook'.

	catalog := Bag new.
	catalog add: aBook.
	
	priceBook := Association key: aBook value: 1.
	
	priceList := Dictionary new.
	priceList add: priceBook.
	
	cart := Cart withCatalog: catalog.
	cart add: aBook. 
	
	aMerchantProcessor := PlagableMerchantProcessor withValidator: [ :anAmount :aCreditCard | 
		Error signal: 'Cannot checkout payment with an empty credit card' ].
	
	cashier := Cashier withPriceList: priceList withMerchantProcessor: aMerchantProcessor.
	
	emptyCreditCard := self newEmptyCreditCard.
	
	self should: [cashier checkout: cart with: emptyCreditCard ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cashier emptyCreditCard ]! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 21:02'!
test5aBookCanBeAddedMoreThanOnce
	| cart book anotherBook catalog |
	
	book := 'aBook'.
	anotherBook := 'anotherBook'.
	catalog := Bag new.
	catalog add: book.
	catalog add: anotherBook.
	
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	cart add: book.
	cart add: anotherBook.
	
	self assert: (cart includes: book).
	self assert: cart size = 3.
	self assert: (cart numberOfUnitsAddedOf: book) = 2.
	self assert: (cart numberOfUnitsAddedOf: anotherBook) = 1.! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'SebaTorres 6/10/2013 12:59'!
test6booksThatAreNotOnTheCatalogCantBeAddedToCart
	| cart book |
	
	cart := self emptyCart.
	book := 'aBook'.
	
	self should: [cart add: book ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cart productNotInCatalog ]! !

!TusLibrosTest methodsFor: '2 - Cashier Test' stamp: 'SebaTorres 6/10/2013 12:40'!
test6cashierCantCheckoutStolenCreditCard

	| aBook catalog priceBook priceList cart cashier stolenCreditCard aMerchantProcessor |
	aBook := 'aBook'.

	catalog := Bag new.
	catalog add: aBook.
	
	priceBook := Association key: aBook value: 1.
	
	priceList := Dictionary new.
	priceList add: priceBook.
	
	cart := Cart withCatalog: catalog.
	cart add: aBook. 
	
	aMerchantProcessor := PlagableMerchantProcessor withValidator: [ :anAmount :aCreditCard | 
		Error signal: 'Cannot checkout payment with a stolen credit card. Calling the cops' ].
	
	cashier := Cashier withPriceList: priceList withMerchantProcessor: aMerchantProcessor.
	
	stolenCreditCard := self newStolenCreditCard.
	
	self should: [cashier checkout: cart with: stolenCreditCard ]
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: anError description = Cashier stolenCreditCard ]! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 20:39'!
test7onlyBooksFromCatalogCanBeAddedToCart
	| cart book catalog |
	
	book := 'aBook'.
	catalog := Bag new.
	catalog add: book.
	cart := Cart withCatalog: catalog.
	
	cart add: book.
	
	self assert: (cart includes: book).
	self assert: cart size = 1.! !
